version: '3.3'
volumes:
  database_volume: {}

networks:
  default: {}
  public:
    external: true

services:
  api:
    build:
      context: .
      dockerfile: .devops/docker/api/Dockerfile
    depends_on:
      - database
    env_file: .env
    networks:
      - default
    volumes:
      - ./api:/app/api
    working_dir: /app

  database:
    build:
      context: .
      dockerfile: .devops/docker/database/Dockerfile
    env_file: .env
    networks:
      default:
        aliases:
          - database.#x#PROJECT_NAME#x#.docker
    volumes:
      - database_volume:/var/lib/mysql

  frontend:
    build:
      context: .
      dockerfile: .devops/docker/frontend/Dockerfile
    env_file: .env
    networks:
      - default
    volumes:
      - ./frontend:/app
    working_dir: /app

  proxy:
    build:
      context: .
      dockerfile: .devops/docker/proxy/Dockerfile
    depends_on:
      - api
      - frontend
    env_file: .env
    labels:
      - traefik.backend=#x#PROJECT_NAME#x#
      - traefik.frontend.rule=Host:dev.#x#PROJECT_NAME#x#.docker
      - traefik.docker.network=public
      - traefik.port=80
    networks:
      default:
        aliases:
          - dev.#x#PROJECT_NAME#x#.docker
      public: {}
    volumes:
      - ./api/static:/app/api/v1/static
